// Copyright (c) Facebook, Inc. and its affiliates.
//
// This source code is licensed under the MIT license found in the
// LICENSE file in the "hack" directory of this source tree.

use std::io::Write;
use std::path::Path;

// generated by gen_hhi_contents.rs
mod hhi_contents;

pub fn write_hhi_files(dir: &Path) -> std::io::Result<()> {
    for (filename, contents) in hhi_contents::HHI_CONTENTS {
        let filename = dir.join(filename);
        std::fs::create_dir_all(filename.parent().unwrap())?;
        let mut file = std::fs::File::create(filename)?;
        file.write_all(contents.as_bytes())?;
    }
    Ok(())
}
